// $Id: drupal.dom.js,v 1.1 2006/05/28 19:16:22 timcn Exp $

Drupal.DOM = {
  // returns true if 'node' has all classes in the array 'classNames'
  hasClasses: function(node, classNames) {
    return classNames.contains(node.className.split(' '));
  },

  // adds all classes in the array 'classNames' to 'node' if they aren't already present
  addClasses: function(node, classNames) {
    node.className += ' ' + classNames.exfiltrate(node.className.split(' ')).join(' ');
  },

  // removes all classes in the array 'classNames' from 'node' if the are present
  removeClasses: function(node, classNames) {
    node.className = node.className.split(' ').exfiltrate(classNames).join(' ');
  }
};
