// $Id: drupal.js,v 1.1 2006/05/28 19:16:22 timcn Exp $

var Drupal = {};


if (!Array.forEach) {
  // executes 'callback' for each item in the array in the context 'thisObject'
  Array.prototype.forEach = function(callback, thisObject) {
    for (var i in this) callback.call(thisObject || window, this[i], i, this);
  }
}


if (!Array.every) {
  // returns true if 'callback' in the context 'thisObject' returns true for each item in the array
  Array.prototype.every = function(callback, thisObject) {
    for (var i in this) if (!callback.call(thisObject || window, this[i], i, this)) return false;
    return true;
  }
}

if (!Array.filter) {
  // returns all items in the array for which 'callback' in the context 'thisObject' returns true
  Array.prototype.filter = function(callback, thisObject) {
    var returnValue = [];
    for (var i in this) if (callback.call(thisObject || window, this[i], i, this)) returnValue.push(this[i]);
    return returnValue;
  }
}

if (!Array.indexOf) {
  // returns the index of 'searchElement'
  Array.prototype.indexOf = function(searchElement, fromIndex) {
    for (var i = (fromIndex || 0), l = this.length; i < l; i++) if (this[i] == searchElement) return i;
    return -1;
  }
}

if (!Array.push) {
  // appends all passed values to the array
  Array.prototype.push = function() {
    for (var i = 0, l = this.length, a = arguments.length; i < a; i++) {
      this[l + i] = arguments[i];
    }
    return l + i;
  }
}

// returns true if every element in 'elements' is in the array
Array.prototype.contains = function(elements) {
  return this.every(function(element) { return this.indexOf(element) >= 0; }, elements);
}

// returns the array without the elements in 'elements'
Array.prototype.exfiltrate = function(elements) {
  return this.filter(function(element) { return this.indexOf(element) < 0; }, elements);
}